Index: /trunk/kernel/fs/vfs.c
===================================================================
--- /trunk/kernel/fs/vfs.c	(revision 656)
+++ /trunk/kernel/fs/vfs.c	(revision 657)
@@ -3,5 +3,5 @@
  *
  * Author  Mohamed Lamine Karaoui (2015)
- *         Alain Greiner (2016,2017,2018,2019)
+ *         Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -33,5 +33,4 @@
 #include <xhtab.h>
 #include <string.h>
-#include <rpc.h>
 #include <errno.h>
 #include <kmem.h>
@@ -59,7 +58,7 @@
 //////////////////////////////////////////////////////////////////////////////////////////
 
-////////////////////////////////////////
-void vfs_ctx_init( vfs_fs_type_t   type,
-                   uint32_t        attr,
+///////////////////////////////////////
+void vfs_ctx_init( cxy_t           cxy,
+                   vfs_fs_type_t   fs_type,
 	               uint32_t        total_clusters,
 	               uint32_t        cluster_size,
@@ -67,43 +66,58 @@
                    void          * extend )
 {
-    vfs_ctx_t * vfs_ctx = &fs_context[type];
-
-    vfs_ctx->type           = type;
-    vfs_ctx->attr           = attr;
-    vfs_ctx->total_clusters = total_clusters;
-    vfs_ctx->cluster_size   = cluster_size;
-    vfs_ctx->vfs_root_xp    = vfs_root_xp;
-    vfs_ctx->extend         = extend;
-
-    busylock_init( &vfs_ctx->lock , LOCK_VFS_CTX );
-
-    bitmap_init( vfs_ctx->bitmap , BITMAP_SIZE(CONFIG_VFS_MAX_INODES) ); 
-}
-
-////////////////////////////////////////////
-error_t vfs_ctx_inum_alloc( vfs_ctx_t * ctx,
+    // get pointer on relevant VFS context (same in all clusters) 
+    vfs_ctx_t * vfs_ctx_ptr = &fs_context[fs_type];
+
+    // initialise VFS context fields 
+    hal_remote_s32( XPTR( cxy , &vfs_ctx_ptr->type           ) , fs_type );
+    hal_remote_s32( XPTR( cxy , &vfs_ctx_ptr->total_clusters ) , total_clusters );
+    hal_remote_s32( XPTR( cxy , &vfs_ctx_ptr->cluster_size   ) , cluster_size );
+    hal_remote_s64( XPTR( cxy , &vfs_ctx_ptr->vfs_root_xp    ) , vfs_root_xp );
+    hal_remote_spt( XPTR( cxy , &vfs_ctx_ptr->extend         ) , extend );
+
+    // initialize VFS context lock
+    remote_busylock_init( XPTR( cxy , &vfs_ctx_ptr->lock ) , LOCK_VFS_CTX );
+
+    // initialize inum allocator
+    bitmap_remote_init( XPTR( cxy , &vfs_ctx_ptr->bitmap ),
+                        BITMAP_SIZE(CONFIG_VFS_MAX_INODES) ); 
+
+} // end vfs_ctx_init()
+
+///////////////////////////////////////////////
+error_t vfs_ctx_inum_alloc( xptr_t      ctx_xp,
                             uint32_t  * inum )
 {
+    // get context cluster and local pointer
+    cxy_t       ctx_cxy = GET_CXY( ctx_xp );
+    vfs_ctx_t * ctx_ptr = GET_PTR( ctx_xp );
+
+    // build extended pointer on lock protecting the inum allocator
+    xptr_t lock_xp = XPTR( ctx_cxy , &ctx_ptr->lock );
+
+    // build extended pointer on inum bitmap
+    xptr_t bitmap_xp = XPTR( ctx_cxy , &ctx_ptr->bitmap );
+
     // get lock on inum allocator
-    busylock_acquire( &ctx->lock );
+    remote_busylock_acquire( lock_xp );
 
     // get lid from local inum allocator
-    uint32_t lid = bitmap_ffc( ctx->bitmap , CONFIG_VFS_MAX_INODES );
+    uint32_t lid = bitmap_remote_ffc( bitmap_xp , CONFIG_VFS_MAX_INODES );
 
     if( lid == 0xFFFFFFFF )   // no more free slot => error
     {
         // release lock
-        busylock_release( &ctx->lock );
+        remote_busylock_release( lock_xp );
 
         // return error
-        return 1;
+        return -1;
     }
     else              // found => return inum
     {
         // set slot allocated
-        bitmap_set( ctx->bitmap , lid );
+        bitmap_remote_set( bitmap_xp , lid );
 
         // release lock
-        busylock_release( &ctx->lock );
+        remote_busylock_release( lock_xp );
 
         // return inum
@@ -111,12 +125,29 @@
         return 0;
     }
-}
-
-////////////////////////////////////////////
-void vfs_ctx_inum_release( vfs_ctx_t * ctx,
-                           uint32_t    inum )
-{
-    bitmap_clear( ctx->bitmap , inum & 0xFFFF ); 
-}
+}  // end vfs_ctx_inum_alloc()
+
+/////////////////////////////////////////////
+void vfs_ctx_inum_release( xptr_t     ctx_xp,
+                           uint32_t   inum )
+{
+    // get context cluster and local pointer
+    cxy_t       ctx_cxy = GET_CXY( ctx_xp );
+    vfs_ctx_t * ctx_ptr = GET_PTR( ctx_xp );
+
+    // build extended pointer on inum bitmap
+    xptr_t bitmap_xp = XPTR( ctx_cxy , &ctx_ptr->bitmap );
+
+    // build extended pointer on lock
+    xptr_t lock_xp = XPTR( ctx_cxy , &ctx_ptr->lock );
+
+    // get lock 
+    remote_busylock_acquire( lock_xp );
+
+    bitmap_remote_clear( bitmap_xp , inum & 0xFFFF ); 
+
+    // release lock
+    remote_busylock_release( lock_xp );
+
+}  // end vfs_ctx_inum_release()
 
 //////////////////////////////////////////////////////////////////////////////////////////
@@ -140,6 +171,7 @@
 }
 
-////////////////////////////////////////////////////
-error_t vfs_inode_create( vfs_fs_type_t     fs_type,
+////////////////////////////////////////////////
+error_t vfs_inode_create( cxy_t             cxy,
+                          vfs_fs_type_t     fs_type,
                           uint32_t          attr,
                           uint32_t          rights,
@@ -148,10 +180,10 @@
                           xptr_t          * inode_xp )
 {
-    mapper_t         * mapper;     // associated mapper( to be allocated)
-    vfs_inode_t      * inode;      // inode descriptor (to be allocated)
-    
-    uint32_t           inum;       // inode identifier (to be allocated)
-    vfs_ctx_t        * ctx;        // file system context 
-	kmem_req_t         req;        // request to kernel memory allocator
+    xptr_t             mapper_xp;    // extended pointer on associated mapper
+    mapper_t         * mapper_ptr;   // local pointer on associated mapper
+    vfs_inode_t      * inode_ptr;    // local pointer on allocated inode
+    uint32_t           inum;         // inode identifier (to be allocated)
+    vfs_ctx_t        * ctx;          // file system context 
+	kmem_req_t         req;          // request to kernel memory allocator
     error_t            error;
 
@@ -166,71 +198,73 @@
     }
 
-    // allocate inum
-    error = vfs_ctx_inum_alloc( ctx , &inum );
-
-    if( error )
-    {
-        printk("\n[ERROR] in %s : cannot allocate inum\n", __FUNCTION__ );
-        return -1;
-    }
-
-    // allocate memory for mapper
-    mapper = mapper_create( fs_type );
-
-    if( mapper == NULL )
-    {
-        printk("\n[ERROR] in %s : cannot allocate mapper\n", __FUNCTION__ );
-        vfs_ctx_inum_release( ctx , inum );
-        return ENOMEM;
-    }
-
 // check inode descriptor contained in one page
 assert( (sizeof(vfs_inode_t) <= CONFIG_PPM_PAGE_SIZE),
 "inode descriptor must fit in one page" );
 
+    // allocate inum
+    error = vfs_ctx_inum_alloc( XPTR( cxy , ctx ) , &inum );
+
+    if( error )
+    {
+        printk("\n[ERROR] in %s : cannot allocate inum\n", __FUNCTION__ );
+        return -1;
+    }
+
+    // allocate memory for mapper in cluster cxy
+    mapper_xp = mapper_create( cxy , fs_type );
+
+    if( mapper_xp == XPTR_NULL )
+    {
+        printk("\n[ERROR] in %s : cannot allocate mapper\n", __FUNCTION__ );
+        vfs_ctx_inum_release( XPTR( cxy , ctx ) , inum );
+        return -1;
+    }
+
+    mapper_ptr = GET_PTR( mapper_xp );
+
     // allocate one page for VFS inode descriptor
-    // because the embedded "children xhtab footprint
-	req.type  = KMEM_PPM;
-	req.order = 0;
-    req.flags = AF_KERNEL | AF_ZERO;
-	inode     = kmem_alloc( &req );
-
-    if( inode == NULL )
+    // because the embedded "children" xhtab footprint
+	req.type   = KMEM_PPM;
+	req.order  = 0;
+    req.flags  = AF_KERNEL | AF_ZERO;
+	inode_ptr  = kmem_remote_alloc( cxy , &req );
+
+    if( inode_ptr == NULL )
     {
         printk("\n[ERROR] in %s : cannot allocate inode descriptor\n", __FUNCTION__ );
-        vfs_ctx_inum_release( ctx , inum );
-        mapper_destroy( mapper );
+        vfs_ctx_inum_release( XPTR( cxy , ctx ) , inum );
+        mapper_destroy( mapper_xp );
         return -1;
     }
 
+    // initialise inode field in mapper
+    hal_remote_spt( XPTR( cxy , &mapper_ptr->inode ) , inode_ptr );
+ 
     // initialize inode descriptor
-    inode->type       = INODE_TYPE_FILE;     // default value
-    inode->inum       = inum;
-    inode->attr       = attr;
-    inode->rights     = rights;
-    inode->uid        = uid;
-    inode->gid        = gid;
-    inode->ctx        = ctx;
-    inode->mapper     = mapper;
-    inode->extend     = NULL;
-    inode->links      = 0;
-
-    // initialise inode field in mapper
-    mapper->inode     = inode;
- 
+    hal_remote_s32( XPTR( cxy , &inode_ptr->type   ) , INODE_TYPE_FILE );  // default value
+    hal_remote_s32( XPTR( cxy , &inode_ptr->inum   ) , inum );  
+    hal_remote_s32( XPTR( cxy , &inode_ptr->attr   ) , attr );  
+    hal_remote_s32( XPTR( cxy , &inode_ptr->rights ) , rights );  
+    hal_remote_s32( XPTR( cxy , &inode_ptr->links  ) , 0 );
+    hal_remote_s32( XPTR( cxy , &inode_ptr->uid    ) , uid );  
+    hal_remote_s32( XPTR( cxy , &inode_ptr->gid    ) , gid );  
+    hal_remote_spt( XPTR( cxy , &inode_ptr->ctx    ) , ctx );  
+    hal_remote_spt( XPTR( cxy , &inode_ptr->mapper ) , mapper_ptr );  
+    hal_remote_spt( XPTR( cxy , &inode_ptr->extend ) , NULL );  
+
     // initialize chidren dentries xhtab
-    xhtab_init( &inode->children , XHTAB_DENTRY_TYPE );
+    xhtab_init( XPTR( cxy , &inode_ptr->children ) , XHTAB_DENTRY_TYPE );
 
     // initialize parents dentries xlist
-    xlist_root_init( XPTR( local_cxy , &inode->parents ) );
+    xlist_root_init( XPTR( cxy , &inode_ptr->parents ) );
  
     // initialize lock protecting size 
-    remote_rwlock_init( XPTR( local_cxy , &inode->size_lock ), LOCK_VFS_SIZE );
+    remote_rwlock_init( XPTR( cxy , &inode_ptr->size_lock ), LOCK_VFS_SIZE );
 
     // initialise lock protecting inode tree traversal
-    remote_rwlock_init( XPTR( local_cxy , &inode->main_lock ), LOCK_VFS_MAIN );
+    remote_rwlock_init( XPTR( cxy , &inode_ptr->main_lock ), LOCK_VFS_MAIN );
 
     // return extended pointer on inode
-    *inode_xp = XPTR( local_cxy , inode );
+    *inode_xp = XPTR( cxy , inode_ptr );
 
 #if DEBUG_VFS_INODE_CREATE
@@ -238,6 +272,6 @@
 thread_t *     this       = CURRENT_THREAD;
 if( DEBUG_VFS_INODE_CREATE < cycle )
-printk("\n[%s] thread[%x,%x] created inode (%x,%x) / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, local_cxy, inode, cycle );
+printk("\n[%s] thread[%x,%x] created inode (%x,%x) / ctx %x / fs_type %d / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, cxy, inode_ptr, ctx, ctx->type, cycle );
 #endif
  
@@ -246,15 +280,19 @@
 }  // end vfs_inode_create()  
 
-/////////////////////////////////////////////
-void vfs_inode_destroy( vfs_inode_t * inode )
-{
+//////////////////////////////////////////
+void vfs_inode_destroy( xptr_t  inode_xp )
+{
+    // get cluster and local pointer
+    vfs_inode_t * inode_ptr = GET_PTR( inode_xp );
+    cxy_t         inode_cxy = GET_CXY( inode_xp );
+
     // release memory allocated for mapper
-    mapper_destroy( inode->mapper );
-
-    // release memory allocate for inode descriptor
+    mapper_destroy( XPTR( inode_cxy , &inode_ptr->mapper ) );
+
+    // release memory allocated for inode descriptor
 	kmem_req_t req;
 	req.type  = KMEM_PPM;
-	req.ptr   = inode;
-	kmem_free( &req );
+	req.ptr   = inode_ptr;
+	kmem_remote_free( inode_cxy , &req );
 
 }  // end vfs_inode_destroy()
@@ -339,6 +377,6 @@
     
     // get inode cluster and local pointer
+    inode_ptr = GET_PTR( inode_xp );
     inode_cxy = GET_CXY( inode_xp );
-    inode_ptr = GET_PTR( inode_xp );
 
     // build extended pointer on parents dentries root
@@ -367,26 +405,27 @@
 }  // end vfs_inode_get_name()
 
-///////////////////////////////////////////////////////
-error_t vfs_inode_load_all_pages( vfs_inode_t * inode )
-{
-
-assert( (inode != NULL) , "inode pointer is NULL" );
-
+////////////////////////////////////////////////////
+error_t vfs_inode_load_all_pages( xptr_t  inode_xp )
+{
     uint32_t   page_id;
     xptr_t     page_xp;
 
-    mapper_t * mapper = inode->mapper;
-    uint32_t   size   = inode->size;
-
-assert( (mapper != NULL) , "mapper pointer is NULL" );
+
+    // get inode cluster and local pointer
+    vfs_inode_t * inode_ptr = GET_PTR( inode_xp );
+    cxy_t         inode_cxy = GET_CXY( inode_xp );
+
+    // get pointer on mapper and size
+    mapper_t * mapper = hal_remote_lpt( XPTR( inode_cxy , &inode_ptr->mapper ) );
+    uint32_t   size   = hal_remote_l32( XPTR( inode_cxy , &inode_ptr->size ) );
 
 #if DEBUG_VFS_INODE_LOAD_ALL
+char       name[CONFIG_VFS_MAX_NAME_LENGTH];
 uint32_t   cycle = (uint32_t)hal_get_cycles();
 thread_t * this  = CURRENT_THREAD;
-char       name[CONFIG_VFS_MAX_NAME_LENGTH];
-vfs_inode_get_name( XPTR( local_cxy , inode ) , name );
+vfs_inode_get_name( inode_xp , name );
 if( DEBUG_VFS_INODE_LOAD_ALL < cycle )
 printk("\n[%s] thread[%x,%x] enter for <%s> in cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, name, local_cxy, cycle );
+__FUNCTION__, this->process->pid, this->trdid, name, inode_cxy, cycle );
 #endif
 
@@ -400,5 +439,5 @@
         // If the mage is missing, this function allocates the missing page,
         // and load the page from IOC device into mapper
-        page_xp = mapper_remote_get_page( XPTR( local_cxy , mapper ), page_id );
+        page_xp = mapper_get_page( XPTR( inode_cxy , mapper ), page_id );
 
         if( page_xp == XPTR_NULL ) return -1;
@@ -408,6 +447,6 @@
 cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_VFS_INODE_LOAD_ALL < cycle )
-printk("\n[%s] thread[%x,%x] exit for <%x> in cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, name, local_cxy, cycle );
+printk("\n[%s] thread[%x,%x] exit for <%s> in cluster %x\n",
+__FUNCTION__, this->process->pid, this->trdid, name, inode_cxy );
 #endif
 
@@ -425,4 +464,5 @@
     vfs_inode_get_name( inode_xp , name );
 
+    // get inode cluster and local pointer
     cxy_t         inode_cxy = GET_CXY( inode_xp );
     vfs_inode_t * inode_ptr = GET_PTR( inode_xp );
@@ -461,12 +501,21 @@
 //////////////////////////////////////////////////////////////////////////////////////////
 
-///////////////////////////////////////////////////
-error_t vfs_dentry_create( vfs_fs_type_t   fs_type,
+///////////////////////////////////////////////
+error_t vfs_dentry_create( cxy_t           cxy,
+                           vfs_fs_type_t   fs_type,
                            char          * name,
                            xptr_t        * dentry_xp )
 {
-    vfs_ctx_t      * ctx;        // context descriptor
-    vfs_dentry_t   * dentry;     // dentry descriptor (to be allocated)
-	kmem_req_t       req;        // request to kernel memory allocator
+	kmem_req_t       req;            // request to kernel memory allocator
+    vfs_ctx_t      * ctx = NULL;     // context descriptor
+    vfs_dentry_t   * dentry_ptr;     // dentry descriptor (to be allocated)
+
+#if DEBUG_VFS_DENTRY_CREATE
+thread_t * this  = CURRENT_THREAD;
+uint32_t   cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_VFS_DENTRY_CREATE < cycle )
+printk("\n[%s] thread[%x,%x] enters for <%s> /  fs_type %x / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, name, fs_type, cycle );
+#endif
 
     // get pointer on context
@@ -476,5 +525,5 @@
     else 
     {
-        ctx = NULL;
+        printk("\n[ERROR] in %s undefined fs_type %d\n", __FUNCTION__, fs_type );
         return -1;
     }
@@ -483,13 +532,13 @@
     uint32_t length = strlen( name );
 
-    if( length >= CONFIG_VFS_MAX_NAME_LENGTH ) return EINVAL;
+    if( length >= CONFIG_VFS_MAX_NAME_LENGTH ) return -1;
 
     // allocate memory for dentry descriptor
-	req.type  = KMEM_KCM;
-	req.order = bits_log2( sizeof(vfs_dentry_t) );
-    req.flags = AF_KERNEL | AF_ZERO;
-	dentry    = kmem_alloc( &req );
-
-    if( dentry == NULL ) 
+	req.type   = KMEM_KCM;
+	req.order  = bits_log2( sizeof(vfs_dentry_t) );
+    req.flags  = AF_KERNEL | AF_ZERO;
+	dentry_ptr = kmem_remote_alloc( cxy , &req );
+
+    if( dentry_ptr == NULL ) 
     {
         printk("\n[ERROR] in %s : cannot allocate dentry descriptor\n",
@@ -499,18 +548,19 @@
 
     // initialize dentry descriptor
-    dentry->ctx     = ctx;
-    dentry->length  = length;
-    dentry->extend  = NULL;
-    strcpy( dentry->name , name );
+    hal_remote_spt( XPTR( cxy , &dentry_ptr->ctx    ) , ctx );
+    hal_remote_s32( XPTR( cxy , &dentry_ptr->length ) , length );
+    hal_remote_spt( XPTR( cxy , &dentry_ptr->extend ) , NULL );
+
+    // register name
+    hal_remote_strcpy( XPTR( cxy, dentry_ptr->name ),
+                       XPTR( local_cxy, name ) );
 
     // return extended pointer on dentry 
-    *dentry_xp = XPTR( local_cxy , dentry );
+    *dentry_xp = XPTR( cxy , dentry_ptr );
 
 #if DEBUG_VFS_DENTRY_CREATE
-thread_t * this  = CURRENT_THREAD;
-uint32_t   cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_VFS_DENTRY_CREATE < cycle )
-printk("\n[%s] thread[%x,%x] created dentry <%s> : (%x,%x) / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, name, local_cxy, dentry, cycle );
+printk("\n[%s] thread[%x,%x] exit for <%s> / dentry (%x,%x)\n",
+__FUNCTION__, this->process->pid, this->trdid, name, cxy, dentry_ptr );
 #endif
 
@@ -519,12 +569,16 @@
 }  // end vfs_dentry_create()
 
-////////////////////////////////////////////////
-void vfs_dentry_destroy( vfs_dentry_t * dentry )
-{
+////////////////////////////////////////////
+void vfs_dentry_destroy( xptr_t  dentry_xp )
+{
+    // get cluster and local pointer
+    vfs_dentry_t * dentry_ptr = GET_PTR( dentry_xp );
+    cxy_t          dentry_cxy = GET_CXY( dentry_xp );
+  
     // release memory allocated to dentry
 	kmem_req_t req;
 	req.type  = KMEM_KCM;
-	req.ptr   = dentry;
-	kmem_free( &req );
+	req.ptr   = dentry_ptr;
+	kmem_remote_free( dentry_cxy , &req );
 
 }  // end vfs_dentry_destroy()
@@ -536,10 +590,17 @@
 
 /////////////////////////////////////////////
-error_t vfs_file_create( vfs_inode_t * inode,
-                         uint32_t      attr,
-                         xptr_t      * file_xp )
-{
-    vfs_file_t  * file;
+error_t vfs_file_create( xptr_t     inode_xp,
+                         uint32_t   attr,
+                         xptr_t   * file_xp )
+{
+    vfs_file_t  * file_ptr;
 	kmem_req_t    req;
+    uint32_t      type;
+    mapper_t    * mapper;
+    vfs_ctx_t   * ctx;
+
+    // get inode cluster and local pointer
+    vfs_inode_t * inode_ptr = GET_PTR( inode_xp );
+    cxy_t         inode_cxy = GET_CXY( inode_xp );
 
 #if DEBUG_VFS_FILE_CREATE
@@ -547,6 +608,6 @@
 uint32_t cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_VFS_OPEN < cycle )
-printk("\n[%s] thread[%x,%x] enter for inode %x in cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, inode, local_cxy, cycle );
+printk("\n[%s] thread[%x,%x] enter for inode (%x,%x) / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, inode_cxy, inode_ptr, cycle );
 #endif
 
@@ -555,27 +616,31 @@
 	req.order = bits_log2( sizeof(vfs_file_t) );
     req.flags = AF_KERNEL | AF_ZERO;
-	file      = kmem_alloc( &req );
-
-    if( file == NULL ) return ENOMEM;
+	file_ptr  = kmem_remote_alloc( inode_cxy , &req );
+
+    if( file_ptr == NULL ) return -1;
+
+    // get type, ctx and mapper from inode descriptor
+    type   = hal_remote_l32( XPTR( inode_cxy , &inode_ptr->type ) );
+    ctx    = hal_remote_lpt( XPTR( inode_cxy , &inode_ptr->ctx ) );
+    mapper = hal_remote_lpt( XPTR( inode_cxy , &inode_ptr->mapper ) );
 
     // initializes new file descriptor
-    file->gc       = 0;
-    file->type     = inode->type;
-    file->attr     = attr;
-    file->offset   = 0;
-    file->refcount = 1;
-    file->inode    = inode;
-    file->ctx      = inode->ctx;
-    file->mapper   = inode->mapper;
-
-    remote_rwlock_init( XPTR( local_cxy , &file->lock ), LOCK_VFS_FILE );
-
-    *file_xp = XPTR( local_cxy , file );
+    hal_remote_s32( XPTR( inode_cxy , &file_ptr->type     ) , type );
+    hal_remote_s32( XPTR( inode_cxy , &file_ptr->attr     ) , attr );
+    hal_remote_s32( XPTR( inode_cxy , &file_ptr->offset   ) , 0 );
+    hal_remote_s32( XPTR( inode_cxy , &file_ptr->refcount ) , 1 );
+    hal_remote_spt( XPTR( inode_cxy , &file_ptr->inode    ) , inode_ptr );
+    hal_remote_spt( XPTR( inode_cxy , &file_ptr->ctx      ) , ctx );
+    hal_remote_spt( XPTR( inode_cxy , &file_ptr->mapper   ) , mapper );
+
+    remote_rwlock_init( XPTR( inode_cxy , &file_ptr->lock ), LOCK_VFS_FILE );
+
+    *file_xp = XPTR( inode_cxy , file_ptr );
 
 #if DEBUG_VFS_FILE_CREATE
 cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_VFS_OPEN < cycle )
-printk("\n[%s] thread[%x,%x] created file %x in cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, file, local_cxy, cycle );
+printk("\n[%s] thread[%x,%x] created file (%x,%x) %x\n",
+__FUNCTION__, this->process->pid, this->trdid, inode_cxy, file_ptr, cycle );
 #endif
 
@@ -584,20 +649,25 @@
 }  // end vfs_file_create()
 
-///////////////////////////////////////////
-void vfs_file_destroy( vfs_file_t *  file )
-{
+////////////////////////////////////////
+void vfs_file_destroy( xptr_t  file_xp )
+{
+    // get file cluster and local pointer
+    vfs_file_t * file_ptr = GET_PTR( file_xp );
+    cxy_t        file_cxy = GET_CXY( file_xp );
+
+    // release file descriptor
 	kmem_req_t req;
 	req.type  = KMEM_KCM;
-	req.ptr   = file;
-	kmem_free( &req );
+	req.ptr   = file_ptr;
+	kmem_remote_free( file_cxy , &req );
 
 #if DEBUG_VFS_CLOSE
 char name[CONFIG_VFS_MAX_NAME_LENGTH];
-vfs_file_get_name( XPTR( local_cxy , file ) , name );
+vfs_file_get_name( file_xp , name );
 thread_t * this = CURRENT_THREAD;
 uint32_t cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_VFS_CLOSE < cycle )
 printk("\n[%s] thread[%x,%x] deleted file <%s> in cluster %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, name, local_cxy, cycle );
+__FUNCTION__, this->process->pid, this->trdid, name, file_cxy, cycle );
 #endif
 
@@ -738,12 +808,5 @@
 
     // create a new file descriptor in cluster containing inode
-    if( inode_cxy == local_cxy )      // target cluster is local
-    {
-        error = vfs_file_create( inode_ptr , file_attr , &file_xp );
-    }
-    else                              // target cluster is remote
-    {
-        rpc_vfs_file_create_client( inode_cxy , inode_ptr , file_attr , &file_xp , &error );
-    }
+    error = vfs_file_create( inode_xp , file_attr , &file_xp );
 
     if( error )  return error;
@@ -764,6 +827,7 @@
 cycle = (uint32_t)hal_get_cycles();
 if( DEBUG_VFS_OPEN < cycle )
-printk("\n[%s] thread[%x,%x] exit for <%s> / fdid %d / cxy %x / cycle %d\n",
-__FUNCTION__, process->pid, this->trdid, path, file_id, GET_CXY( file_xp ), cycle );
+printk("\n[%s] thread[%x,%x] exit for <%s> / fdid %d / file(%x,%x) / cycle %d\n",
+__FUNCTION__, process->pid, this->trdid, path, file_id,
+GET_CXY( file_xp ), GET_PTR( file_xp ), cycle );
 #endif
 
@@ -880,6 +944,6 @@
     __FUNCTION__ , this->process->pid, nbytes );
     else            
-    printk("\n[%s] thread[%x,%x] exit / %d bytes moved from buffer to mapper / size %d\n",
-    __FUNCTION__ , this->process->pid, nbytes, hal_remote_l32(XPTR(file_cxy,&inode->size)) );
+    printk("\n[%s] thread[%x,%x] exit / %d bytes moved from buffer to mapper\n",
+    __FUNCTION__ , this->process->pid, nbytes );
 }
 #endif
@@ -1035,5 +1099,5 @@
 {
     cxy_t         file_cxy;         // cluster containing the file descriptor.
-    vfs_file_t  * file_ptr;         // local ponter on file descriptor
+    vfs_file_t  * file_ptr;         // local pointer on file descriptor
     cxy_t         owner_cxy;        // process owner cluster
     pid_t         pid;              // process identifier
@@ -1076,14 +1140,5 @@
 
     // copy all dirty pages from mapper to device
-    if( file_cxy == local_cxy )
-    {
-        error = mapper_sync( mapper_ptr );
-    }
-    else
-    {
-        rpc_mapper_sync_client( file_cxy,
-                                mapper_ptr,
-                                &error );
-    }
+    error = mapper_sync( XPTR( file_cxy , mapper_ptr ) );
 
     if( error )
@@ -1128,18 +1183,6 @@
  
         // update dentry size in parent directory mapper
-        if( parent_cxy == local_cxy )
-        {
-            error = vfs_fs_update_dentry( parent_inode_ptr,
-                                          parent_dentry_ptr,
-                                          size );
-        }
-        else
-        {
-            rpc_vfs_fs_update_dentry_client( parent_cxy,
-                                             parent_inode_ptr,
-                                             parent_dentry_ptr,
-                                             size,
-                                             &error );
-        }
+        error = vfs_fs_update_dentry( XPTR( parent_cxy , parent_inode_ptr ),
+                                      parent_dentry_ptr );
 
         if( error )
@@ -1159,14 +1202,5 @@
 
         // copy all dirty pages from parent mapper to device
-        if( parent_cxy == local_cxy )
-        {
-            error = mapper_sync( parent_mapper_ptr );
-        }
-        else
-        {
-            rpc_mapper_sync_client( parent_cxy,
-                                    parent_mapper_ptr,
-                                    &error );
-        }
+        error = mapper_sync( XPTR( parent_cxy , parent_mapper_ptr ) );
 
         if( error )
@@ -1222,12 +1256,5 @@
     //////// 4) release memory allocated to file descriptor in remote cluster
 
-    if( file_cxy == local_cxy )             // file cluster is local
-    {
-        vfs_file_destroy( file_ptr );
-    }
-    else                                    // file cluster is local
-    {
-        rpc_vfs_file_destroy_client( file_cxy , file_ptr );
-    }
+    vfs_file_destroy( file_xp );
 
 #if DEBUG_VFS_CLOSE
@@ -1320,19 +1347,8 @@
 
     // 2. create one new dentry in parent cluster
-    if( parent_cxy == local_cxy )  
-    {
-        error = vfs_dentry_create( parent_fs_type,
-                                   last_name,
-                                   &dentry_xp );
-    }
-    else
-    {
-        rpc_vfs_dentry_create_client( parent_cxy,
-                                      parent_fs_type,
-                                      last_name,
-                                      &dentry_xp,
-                                      &error );
-    }
-
+    error = vfs_dentry_create( parent_cxy,
+                               parent_fs_type,
+                               last_name,
+                               &dentry_xp );
     if( error )
     {
@@ -1361,32 +1377,18 @@
     inode_cxy = cluster_random_select();
     
-    if( inode_cxy == local_cxy )      // target cluster is local 
-    {
-        error = vfs_inode_create( parent_fs_type,
-                                  attr,
-                                  rights,
-                                  uid,
-                                  gid,
-                                  &inode_xp );
-    }
-    else                              // target cluster is remote
-    {
-        rpc_vfs_inode_create_client( inode_cxy,
-                                     parent_fs_type,
-                                     attr,
-                                     rights,
-                                     uid,
-                                     gid,
-                                     &inode_xp,
-                                     &error );
-    }
-                                     
+    // create inode
+    error = vfs_inode_create( inode_cxy,
+                              parent_fs_type,
+                              attr,
+                              rights,
+                              uid,
+                              gid,
+                              &inode_xp );
     if( error )
     {
         remote_rwlock_wr_release( lock_xp );
         printk("\n[ERROR] in %s : cannot create new inode in cluster %x for <%s>\n",
-               __FUNCTION__ , inode_cxy , path );
-        if( parent_cxy == local_cxy ) vfs_dentry_destroy( dentry_ptr );
-        else rpc_vfs_dentry_destroy_client( parent_cxy , dentry_ptr );
+         __FUNCTION__ , inode_cxy , path );
+        vfs_dentry_destroy( dentry_xp );
         return -1;
     }
@@ -1434,7 +1436,6 @@
         remote_rwlock_wr_release( lock_xp );
         printk("\n[ERROR] in %s : cannot create new inode in cluster %x for <%s>\n",
-               __FUNCTION__ , inode_cxy , path );
-        if( parent_cxy == local_cxy ) vfs_dentry_destroy( dentry_ptr );
-        else rpc_vfs_dentry_destroy_client( parent_cxy , dentry_ptr );
+        __FUNCTION__ , inode_cxy , path );
+        vfs_dentry_destroy( dentry_xp );
         return -1;
     }
@@ -1445,17 +1446,6 @@
     // 8. update parent directory mapper 
     //    and synchronize the parent directory on IOC device
-    if (parent_cxy == local_cxy)
-    {
-        error = vfs_fs_add_dentry( parent_ptr,
-                                   dentry_ptr );
-    }
-    else
-    {
-        rpc_vfs_fs_add_dentry_client( parent_cxy,
-                                      parent_ptr,
-                                      dentry_ptr,
-                                      &error );
-    }
-
+    error = vfs_fs_add_dentry( parent_xp,
+                               dentry_ptr );
     if( error )
     {
@@ -1589,19 +1579,8 @@
     {
         // 1. create one new dentry
-        if( new_parent_cxy == local_cxy )  
-        {
-            error = vfs_dentry_create( inode_fs_type,
-                                       new_name,
-                                       &dentry_xp );
-        }
-        else
-        {
-            rpc_vfs_dentry_create_client( new_parent_cxy,
-                                          inode_fs_type,
-                                          new_name,
-                                          &dentry_xp,
-                                          &error );
-        }
-
+        error = vfs_dentry_create( new_parent_cxy,
+                                   inode_fs_type,
+                                   new_name,
+                                   &dentry_xp );
         if( error )
         {
@@ -1643,15 +1622,6 @@
         //    and synchronize the parent directory on IOC device
         if (new_parent_cxy == local_cxy)
-        {
-            error = vfs_fs_add_dentry( new_parent_ptr,
-                                       dentry_ptr );
-        }
-        else
-        {
-            rpc_vfs_fs_add_dentry_client( new_parent_cxy,
-                                          new_parent_ptr,
-                                          dentry_ptr,
-                                          &error );
-        }
+        error = vfs_fs_add_dentry( new_parent_xp,
+                                   dentry_ptr );
         if( error )
         {
@@ -1703,5 +1673,6 @@
     vfs_fs_type_t     fs_type;            // File system type
 
-    char              name[CONFIG_VFS_MAX_NAME_LENGTH];  // name of link to remove
+    char              child_name[CONFIG_VFS_MAX_NAME_LENGTH];   // name of link to remove
+    char              parent_name[CONFIG_VFS_MAX_NAME_LENGTH];  // name of parent directory
 
     thread_t  * this    = CURRENT_THREAD;
